#include <fastgl/fastgl.h>

int main(int argc, char **argv)
{
	App MyApp(3, argc, argv, CBLACK, APP_ROOTWINDOW|APP_ENABLEALTX);
	Bitmap icon("../gifread/logo256.gif");
	App::GetRootWindow()->WindowPutBitmap(0, 0, 0,0,X_width, Y_width,&icon);
	
	Bitmap image("../bitmaps/texture.bmp");
	image.SetAlpha(128); // 50% transparency
	App::GetRootWindow()->WindowPutBitmap(300, 200, 0,0, 200, 160, &image);
	image.SetAlpha(80); // 50% transparency
	App::GetRootWindow()->WindowPutBitmap(400, 300, 0,0, 200, 160, &image);
	image.SetAlpha(200); // 50% transparency
	App::GetRootWindow()->WindowPutBitmap(500, 400, 0,0, 200, 160, &image);
#if FASTGL_BPP == 8
	IError("Alpha blending runs with BPP>=15 only!", 0);
#endif	
	MyApp.Run(0);
	return 0;
}
