#include <fastgl/fastgl.h>
#include <stdio.h>
#include <time.h>
#include <stdlib.h>

static char s[80];
static Window *w1;
static int r,g,b;

extern "C" void CreatePaletteEntry(int,int,int,int);

void myexit()
{
	App::AppDone();
}

void SliderProc(Control *)
{
	SendEvent(w1, NOEVENT);
}

void hand5(GuiEvent * p)
{
	int i;
	switch(p->GetType())
	{
		case INITEVENT:
			SetColorFuzzy(0); // disable 'inteligent' color system
			for(i=0;i<16;i++) w1->WindowBox(i*30,0,30,160,i);
			w1->WindowBox(410,170,60,70,16);
			r=128,g=128,b=128;
			w1->AddSlideBarH(10,170, 0,255,1, &r, SliderProc);
			w1->AddSlideBarH(10,190, 0,255,1, &g, SliderProc);
			w1->AddSlideBarH(10,210, 0,255,1, &b, SliderProc);
			break;
		case TERMINATEEVENT:
			myexit();
			break;
		case KEYEVENT: switch(p->GetKey())
		{
			case ESC:
				App::AppDone();
				return;
		}
	}
	set_colors(0,CWHITED);
#ifdef INDEX_COLORS
	CreatePaletteEntry(r,g,b,16);
#endif
	w1->printf(50,234,"Color: 16, Red %d, Green %d, Blue %d    ", r,g,b);
}

int main(int argc, char **argv)
{
	App MyApp(2, argc, argv, 0, APP_ENABLEALTX|APP_WINDOWDATABASE);
	w1 = new Window(&w1, 80, 100, 30*16+8, 280, "Your nice colors", hand5, 0, CWHITED, WSTANDARD|WCENTRED|WESCAPE);
	MyApp.Run(0);
	return 0;
}
