#include <fastgl/fastgl.h>

Window *MyWnd;

int AppProc(GuiEvent *e)
{
	set_colors(CWHITE, CDARK);
	gprintf(16, 580, "APP_PROC: %s[%d] (%d,%d %d)      ", e->GetName(), e->GetType(),e->GetKey(),e->GetX(),e->GetY());
	return 0;
}

void WindowProc(GuiEvent *e)
{
	set_colors(CBLACK, CGRAY2);
	e->wnd->printf("WND_PROC: %s[%d] (%d,%d %d)\n", e->GetName(), e->GetType(),e->GetKey(),e->GetX(),e->GetY());
}

int main(int argc, char **argv)
{
	App MyApp(3, argc, argv, CDARK, APP_ENABLEALTX | APP_MAGNIFIER);
	Window * okno = new Window(&MyWnd, 400, 100, 400, 500, "Window", WindowProc, CBLACK, CGRAY2, WFRAMED | WTITLED);
	new Window(0, 0, 0, 300, 400, "Window 2", WindowProc, 0, CGRAY2, WFRAMED | WTITLED | WNOPICTO | WSIZEABLE);

	set_colors(CGRAYED, CGRAY2);
	okno->printf("TEST FOR EVENTS !\n");
	MyApp.Run(AppProc);
	delete MyWnd;
	return 0;
}
