#include <fastgl/fastgl.h>

#ifdef __rtems__
extern "C" char opengl[] asm("_opengl");			// bitmap in exe
#endif


void myex(Control *)
{
	App::AppDone();
}

int main(int argc, char **argv)
{
	App MyApp(2, argc, argv, CDARK, APP_ALL);
	Window okno(0, X_width / 2 - 200, Y_width / 2 - 100, 400, 200, " Your Pretty Window", GuiHwnd(NULL), CBLACK, CGRAY2, WFRAMED | WTITLED | WMINIMIZE);

#if defined( __rtems__)
	Bitmap icon( ( void *)opengl );
#else
	Bitmap icon("opengl");
#endif
	okno.WindowAttachIcon(&icon);
	set_colors(CGRAYED, CGRAY2);
	okno.printf(54, 75, "Hello from FastGL world !\n");
	okno.AddPushButton(275, 120, 80, 24, "Quit", 'Q', myex);

	MyApp.Run(0);
	return 0;
}
