#include <fastgl/fastgl.h>
#include <fastgl/listbox.h>

FGListBox *a;

void proc(GuiEvent *p)
{
	int rc;
	switch(p->GetType())
	{
		case KEYEVENT:
			// next line is equivalent of rest of this case
//			a->DoListBox(p->GetKey());

			switch(p->GetKey())
			{
			case KUP:
				a->Up();
				break;
			case KDOWN:
				a->Down();
				break;
			case HOME:
				a->Begin();
				break;
			case END:
				a->End();
				break;
			}
			break;
		case CLICKLEFTEVENT:
			rc = a->Test(p->GetX(), p->GetY());
			if (rc>=0) a->SetIndex(rc);
			p->wnd->SetColors(); // set apropriate colors
			p->wnd->printf(8,8,"You clicked to item at index %d", rc);
			break;
		case TERMINATEEVENT:
			// quit app
			App::AppDone();
			break;
	}
}

static void reload(FGListBox * a)
{
	// at the start is FGListBox empty, but else
	// you must first of all reset object to a zero state
	a->clear();
	// insert a ten string items
	// for a delete an items from the list see to 'listbox.h' file
	a->insert("item 1");
	a->insert("item 2");
	a->insert("item 3");
	a->insert("item 4");
	a->insert("item 5");
	a->insert("item 6");
	a->insert("item 7");
	a->insert("item 8");
	a->insert("item 9");
	a->insert("item 10");
	// enable update & redraw object
	a->Update();
}

int main(int argc, char **argv )
{
	App MyApp(3,argc,argv,CGRAY1,APP_ENABLEALTX);
	// create a Window object
	Window *w = new Window(&w,100,1000,300,250, "Okno",proc,0,15,WCLICKABLE|WTITLED|WFRAMED|WCENTRED);

	// create an emty FGListBox object
	a=new FGListBox(40,40,200,18,5,w);

	// load object wiht some items
	reload(a);

	// run program
	MyApp.Run(0);
	return 0;
}
