#include <stdio.h>
#include <time.h>
#include <stdlib.h>
#include <fastgl/fastgl.h>

#if defined ( __WATCOMC__ ) || defined(__rtems__)
#define	random rand
#define	srandom srand
#endif

extern int rnd(int);
#define rnd(a) (random()%(a+1))  // macro for randomize fnc

int a, b;
char s[80];

Window *w1, *w2, *w3, *w4, *w5;

extern "C"
{
	void __crt0_load_environment_file(char *)
	{
	}
	char **__crt0_glob_function(char *)
	{
		return 0;
	}
}

int cas()
{
	static int a = 0, b;

	b = a;
	return ((a = clock()) - b);
}

void rondo()
{
	volatile int i = X_width / 8 / 6, j = Y_width / 16;
	char *s1 = "Rondo ", *s2 = " Rondo";

	for (; j >= 0; j--)
		for (int a = i; a >= 0; a--)
			text_out(a * 8 * 6, j * 16, j & 1 ? s1 : s2);
}

int test2(int x)
{
	int pp[][2] =
	{{10, 10}, {100, 60}, {50, 500}, {100, 400}, {500, 490}, {800, 100}, {10, 10}};
	int i, f;
	FGPixel *p;

	p = (FGPixel *)malloc(X_width * Y_width);
	f = clock();
	for (i = 0; i < 10; i++)
	{
		clear_frame_buffer(i);
	}
	if (x)
		set_ppop(_GXOR);
	for (i = 0; i < 50; i++)
	{
		set_fcolor(i);
		fill_convex(7, pp);
	}
	for (i = 0; i < 1000; i++)
	{
		set_fcolor(i);
		draw_line(0, 0, X_width, i);
		draw_line(0, i, X_width, 0);
	}
	set_ppop(_GSET);
	for (i = 0; i < 600; i++)
	{
		set_fcolor(i);
		fill_box(rnd(X_width), rnd(Y_width),100, 65);
	}
	if (x)
		set_fcolor(_GXOR);
	get_block(0, 0, X_width, Y_width, p);
	for (i = 0; i < 600; i += 5)
	{
		put_block(i, i, X_width, Y_width, p);
	}
	put_block(0, 0, X_width, Y_width, p);
	for (i = 0; i < 600; i += 5)
	{
		put_block(i, 600 - i, X_width, Y_width, p);
	}
	put_block(0, 0, X_width, Y_width, p);
	for (i = 0; i < 600; i += 5)
	{
		put_block(600 - i, 600 - i, X_width, Y_width, p);
	}
	put_block(0, 0, X_width, Y_width, p);
	for (i = 0; i < 600; i += 5)
	{
		put_block(-i, i, X_width, Y_width, p);
	}
	if (x)
		set_ppop(_GAND);
	for (i = 20; i < 130; i++)
	{
		set_fcolor(i);
		draw_circle(X_width / 2, Y_width / 2 - 20, i);
		fill_circle(X_width / 2, Y_width / 2 + 20, i);
	}
	for (i = 45; i < 60; i++)
	{
		set_fcolor(i);
		set_bcolor(i + 16);
		if (x)
			set_ppop(i & 3);
		rondo();
	}
	free(p);
	return clock() - f;
}

int test3()
{
	int i, j, f;

	set_ppop(0);
	f = clock();
	for (j = 0; j < 6000; j++)
	{
		w1->WindowFillCircle(rnd(w1->GetW()), rnd(w1->GetH()), rnd(100), rnd(255));
		w2->WindowText(rnd(w2->GetW()), rnd(w2->GetH()), "Hello", rnd(255), rnd(255));
		set_fcolor(rnd(255));
		w3->WindowBox(rnd(w3->GetW()), rnd(w3->GetH()), 40, 30);
	}
	for (j = 0; j < 256; j++)
		for (i = 0; i < 256; i++)
			w1->WindowPixel(i, j, i + j);
	return clock() - f;
}

void test(Control *)
{
	Window *w = Window::GetCurrent();

	int i;
	cas();
	set_ppop(_GTRANSP);
	FGPixel *mem = (FGPixel *)malloc(X_width*Y_width+10000), *temp;
	assert(temp=mem);
	for(i = X_width*Y_width; i; i--) *temp++ = rnd(255);
	set_fcolor(14);
	for(i=0;i<64;i++)
	{
		put_block(0,0, X_width,Y_width, mem+i*4);
		text_out(20,150,"TRANSPARENT MODE");
	}
	free(mem);
	set_ppop(_GSET);
	a = test2(0);
	b = test2(1);
	set_ppop(_GSET);
	Window::ShowAll();
	sprintf(s, "Graph mark - %d (redraw mode)", a,0);
	set_ppop(_GSET);
	w->WindowText(20, 140, s);
	sprintf(s, "Graph mark - %d (xor mode)", b,0);
	w->WindowText(20, 160, s);
	set_ppop(_GSET);
}

void test1(Control *)
{
	Window *w = Window::GetCurrent();

	cas();
	a = test3();
	sprintf(s, "Graph WinMark - %d", a);
	w->WindowText(20, 180, s);
	set_ppop(_GSET);
}

int AppProc(GuiEvent *)		// if return 0 = exit
{
	return 1;
}

void boxes_remove(GuiEvent *p)
{
	if (p->GetType()==TERMINATEEVENT) cApp->SetDelayProc(0);
}

void boxes(void)
{
	Window *w=cApp->GetRootWindow();
	set_fcolor(rnd(255));
	w->WindowBox(rnd(w->GetWW()), rnd(w->GetHW()), 40, 30);
}

void myexit(Control *)
{
  App::AppDone();
}

void aaa(int)
{
	Puk();
}

void xxx(Control *)
{
	new MenuWindow(130, 20, 100, 130, "dfghkl 2");
}

void hand5(GuiEvent * )
{
}

void kresli1(int x, int y, int c, int ako, void *)
{
	set_colors(ako==0?CWHITED:CWHITE,CBLACK);
	w2->printf(x,y," %03d \n", c);
}

int main(int argc, char **argv)
{
	App MyApp(3, argc, argv, CWHITE, APP_ENABLEALTX|APP_WINDOWDATABASE|APP_ROOTWINDOW);
	int i, j = 7, h = (Y_width / 100) * 40, w = (X_width / 100) * 40;
	double jjj = .88;
	char jj[32]; strcpy(jj,"majo      ");
	Control *eb;

	new Window(&w1, 20, 20, w, h, "Okienko 1", GuiHwnd(NULL), CBLACK, CWHITED, WTITLED);
	new Window(&w2, 20, Y_width / 2 + 20, w, h, "Okienko 2", boxes_remove, 7, 5, WSIZEABLE | WMENU | WTITLED);
	new Window(&w3, X_width / 2 + 20, 20, w, h, "Okienko 3", GuiHwnd(NULL), 7, CWHITE, WNOPICTO | WTITLED );
	new Window(&w4, X_width / 2 + 20, Y_width / 2 + 20, w, h, "Okienko 4", GuiHwnd(NULL), CWHITED, CGREEN, WFRAMED | WSIZEABLE /*| WNOPICTO*/|WMENU);
	new Window(&w5, X_width / 2 - w / 2, Y_width / 2 - h / 2, w, h, "Okienko 5", hand5, 7, 0, WSTANDARD | WSIZEABLE | WUSELAST);

	w1->WindowText(10, 8, "WFILLED|WTITLED|WNOPICTO", CBLACK);
	w2->WindowText(10, 8, "WFILLED|WFRAMED|RESIZEABLE", CWHITE);
	w3->WindowText(10, 8, "WNOPICTO|WTITLED|WFILLED");
	w4->WindowText(10, 8, "(default)", CWHITE);

	sprintf(s, "Resolution %dx%d", X_width, Y_width);
	w3->WindowText(20, 90, s);
	eb = w4->AddEditBox(20, 40, 70, 60, "Input :", 'I', &j, 0, 5, 10);
	((EditBox *) eb)->ChangeItem(&i);
	w4->AddEditBox(20, 70, 70, 60, "Input", 'N', jj, 0);
	w4->AddEditBox(20, 100, 70, 60, "Input :", 'P', &jjj, 0, .5, 1.5);
	eb = w5->AddPushButton(20, 10, 190, 24, "Start Test for Base", 'B', test);
	w5->AddPushButton(20, 40, 190, 24, "Start Test for Window", 'W', test1);
	eb = w5->AddCheckButton(20, 90, "Check Button", 'C');
	w5->AddPointButton(170, 90, "Point Button", 'P');
	eb = w5->AddPushButton(w - 70, 10, 60, 24, "Exit", 'E', myexit);

	eb->SetName("Quit");
	eb->SetKey('Q');
	w3->WindowLine(10, 100, 100, 10, 0);
	w3->WindowLine(100, 100, 10, 10);
	w3->WindowLock();
	set_ppop(_GNOT);
	for (i = 0; i < 300; i++)
	{
		set_fcolor(i);
		w3->WindowLine(0, 0, w, i);
		w3->WindowLine(0, i, w, 0);
	}
	w3->WindowUnLock();
	w2->AddBaseMenu("File ", 'F', 0);
	w2->AddBaseMenu("Edit ", 'E', 0);
	eb = w2->AddBaseMenu("Help ", 'H', 0);
	w2->WindowBox(0, 0, w, h);
	w4->printf(10, 134, "You can move or resize this window\n       like under WIN 95\n   for help run this with -h switch\n");
	MyApp.SetDelayProc(boxes);
	MenuWindow *m = new MenuWindow(0, 0, 120, 100, "Menu WND");

	m->AddMenu("first",'f',xxx);
	m->AddMenu("second",'s');
	m->AddMenu("third",'t');
	m->Separator();
	m->AddMenu("styri",'s');

 	w1->WindowFillCircle(100,100,50,CBLACK);
	int mz[][2]={{62,186},{135,150},{221,197},{377,125},{231,25},{150,85},{10,18},{62,186}};
	set_ppop(_GXOR);
	w1->WindowFillPolygon(8,mz,CRED);
	set_ppop(_GSET);
	w1->WindowDrawPolygon(8,mz,CRED);

	MyApp.Run(AppProc);

	cCfg->WriteString("prvy3","retazec");
	cCfg->WriteInt("prvy2",12345678);
	cCfg->WriteDouble("prvy1",123.435643);
   delete w5;
   delete w4;
   delete w3;
   delete w2;
   delete w1;
	return 0;
}
