#include <fastgl/fastgl.h>
#include <fastgl/widgets.h>

static ProgressBar *pg;
static Window *w; 

void select_file(char *s)
{
	w->SetName(s);
}

void timer(int sec)
{
	pg->setProgress(sec);
}

int main(int argc, char **argv)
{
	
	App app(3,argc, argv, 0, APP_ENABLEALTX);

	new Window(&w,140,340,400,130,"The Window",0,14,4,WNOPICTO|WFRAMED|WTITLED);
	pg = new ProgressBar(w,20,20,352,30, 60);

	FileDialog *a = new FileDialog(select_file, ".", ".cc .o .gpr","Files in this dir", FDIALOG_SAVE);
	
	app.SetTimerProc( timer );
	app.Run();

	delete w;
	return 0;
}
